#include "TStopwatch.h"
#include "TComplex.h"
#include "TH2F.h"
#include "Rtypes.h"

int main()
{
   const int max_iter=50;
   TStopwatch timer;
   TH2F *last_histo = new TH2F("h2","Mandelbrot",200,-2,2,200,-2,2);

   timer.Start();

   for(int bx=1;bx<=last_histo->GetNbinsX();bx++) {
      for(int by=1;by<=last_histo->GetNbinsY();by++) {
         double x=last_histo->GetXaxis()->GetBinCenter(bx);
         double y=last_histo->GetYaxis()->GetBinCenter(by);
         TComplex point( x,y);
         TComplex z=point;
         int iter=0;	
         while (z.Rho()<2){
            z=z*z+point;
            last_histo->Fill(x,y);
            iter++;
            if(iter>max_iter) break;
         }
      }
   }
   timer.Stop();
   printf("RT=%7.3f s, Cpu=%7.3f s\n",timer.RealTime(),timer.CpuTime());
   return 0;
}
